"""
A refactored example program that demonstrates the use of functions as parameterized tools.
It is the AFTER example.
"""


def main():
    target = 'The quick brown fox jumped over the lazy dog.'
    vowels = 'aeiou'
    consonants = 'bcdfghjklmnpqrstvwxyz'
    spaces = ' '
    punctuation_marks = ',.;:!?'

    print(f'The target string is: {target}')
    print(f'It contains {count_qualifying_characters(target, vowels)} vowels.')
    print(f'It contains {count_qualifying_characters(target, consonants)} consonants.')
    print(f'It contains {count_qualifying_characters(target, spaces)} spaces.')
    print(f'It contains {count_qualifying_characters(target, punctuation_marks)} punctuation marks.')


def count_qualifying_characters(string_to_be_analyzed, qualifying_characters):
    overall_count = 0
    shifted_string = string_to_be_analyzed.lower()

    for character in qualifying_characters:
        this_character_count = shifted_string.count(character)
        overall_count += this_character_count

    return overall_count


main()
